program jcRemoveMean
  ! Jason P. Chang
  ! June 2012
  ! Remove mean from traces

  use sep
  implicit none

  ! allocate variable types
  integer                        :: ii
  integer                        :: n1,n2
  real,allocatable,dimension (:) :: data
  double precision               :: mean
  logical                        :: verb

  ! open I/O
  call sep_init()

  call from_param  ('verb',verb,.false.)
  if ( verb ) write(0,*) '-----------------------------------'
  if ( verb ) write(0,*) '    DOUBLE PRECISION MEAN REMOVAL    '
  if ( verb ) write(0,*) '-----------------------------------'
  if ( verb ) write(0,*) '    i/o looping over traces        '

  call from_history('n1',n1)
  call from_history('n2',n2)

  call sep_close()

  ! allocate
  allocate( data(n1) )

  if ( verb ) write(0,*) '-----------------------------------'
  ! loop over all traces
  do ii=1,n2
    data = 0.
    
    ! read in the data
    call sreed('in',data,4*n1)

    ! calculate and remove the mean
    mean = sum(dble(data)) / dble(n1)
    if ( verb ) write(0,"(A,I7.1,A,I7.3,A,D)") 'trace: ',ii,' out of',n2,' mean: ', mean
    data = real(dble(data) - mean)

    ! write out the data
    call srite('out',data,4*n1)

  end do

  ! clean up
  if ( verb ) write(0,*) '-----------------------------------'
  deallocate(data)
  call exit(0)
  
end program jcRemoveMean
