program srClean
  ! Clean a datastream from NaN's, and Inf's
  ! Substitutes zeros

  use sep
  
  integer                          ::   n1,n2,n3,n4,n5,n6
  integer                          ::   jj

  real,allocatable,dimension(:)    ::   trace
  logical                          :: verbose

  ! Open I/O headerfiles 
  call sep_init()
  call from_param('verbose',verbose,.false.)
  call from_param('verb'   ,verbose,verbose)
  if (verbose) write(0,*) '-----------------------------------'
  if (verbose) write(0,*) "    REMOVE NaN's and Inf's         "
  if (verbose) write(0,*) '-----------------------------------'
  if (verbose) write(0,*) '    i/o looping over traces        '

  ! Read and write History
  call from_history('n1',n1,1 )
  call from_history('n2',n2,1 )
  call from_history('n3',n3,1 )
  call from_history('n4',n4,1 )
  call from_history('n5',n5,1 )
  call from_history('n6',n6,1 )
  if (verbose) write(0,"(A,I7.1,I7.1,I7.1,I7.1,I7.1,I7.1)") 'n1,n2,n3,n4,n5,n6 :  ',(/n1,n2,n3,n4,n5,n6/)
  if (verbose) write(0,*) '-----------------------------------'
  call sep_close()

  ! Allocate memory
  allocate ( trace(n1) )



  if (verbose) write(0,*) '-------------------------------------------'
  !!!! Actual Kernel
  do jj=1,n2*n3*n4*n5*n6

    data = 0.
    ! Read the data
    call sreed('in',trace,4*n1)
  
    ! Clean this trace
    where (    trace .ne.     trace ) trace=0.
    where (abs(trace).gt.huge(trace)) trace=0.
    
    ! Write the data
    call srite('out',trace,4*n1)

  end do

  ! Deallocate memory
  if (verbose) write(0,*) '-----------------------------------'
  deallocate(trace)
  call exit(0)

end program
